%define webroot	/var/www

Summary: Tiny, turbo, throttleable lightweight http server.
Name: thttpd
Version: 2.21b
Release: fr0.4
License: BSD
Group: System Environment/Daemons
Source0: http://www.acme.com/software/thttpd/thttpd-%{version}.tar.bz2
Source1: thttpd.init
URL: http://www.acme.com/software/thttpd/
BuildRoot: %{_tmppath}/%{name}-root
PreReq: /sbin/service, /etc/init.d
BuildRequires: perl
Conflicts: apache

%description
Thttpd is a very compact no-frills httpd serving daemon that can handle
very high loads.  While lacking many of the advanced features of
Apache, thttpd operates without forking and is extremely efficient in
memory use.  Basic support for cgi scripts, authentication, and ssi is
provided for.  Advanced features include the ability to throttle traffic.

%prep
%setup -q

%build
%configure
# Hacks :-)
perl -pi -e 's/-o bin -g bin//g' Makefile
perl -pi -e 's/.*chgrp.*//g; s/.*chmod.*//g' extras/Makefile
make WEBDIR=%{webroot}/html CGIBINDIR=%{webroot}/cgi-bin

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{webroot}/{cgi-bin,logs}
mkdir -p %{buildroot}%{_mandir}/man{1,8}
mkdir -p %{buildroot}%{_sbindir}
install -D -m 755 %{SOURCE1} %{buildroot}/etc/init.d/thttpd
make install BINDIR=%{buildroot}%{_sbindir} \
	MANDIR=%{buildroot}%{_mandir} \
	WEBDIR=%{buildroot}%{webroot}/html \
	CGIBINDIR=%{buildroot}%{webroot}/cgi-bin

cat << EOF > %{buildroot}%{_sysconfdir}/thttpd.conf
# BEWARE : No empty lines are allowed!
# This section overrides defaults
dir=%{webroot}/html
chroot
user=thttpd	# default = nobody
logfile=/var/log/thttpd.log
pidfile=/var/run/thttpd.pid
# This section _documents_ defaults in effect
# port=80
# nosymlink	# default = !chroot
# novhost
# nocgipat
# nothrottles
# host=0.0.0.0
# charset=iso-8859-1
EOF

%pre
/usr/sbin/groupadd -r www 2>/dev/null || :
/usr/sbin/useradd -s /bin/false -c "Web server user" \
	-d %{webroot} -M -r -g www thttpd 2>/dev/null || :

%post
if [ $1 = 1 ]; then
	/sbin/chkconfig --add thttpd
fi

%preun
if [ $1 = 0 ]; then
	/sbin/service thttpd stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del thttpd
fi

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service thttpd condrestart >/dev/null 2>&1 || :
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc README TODO
%config /etc/init.d/thttpd
%config(noreplace) %{_sysconfdir}/thttpd.conf
%attr(2755, root, www) %{_sbindir}/makeweb
%{_sbindir}/htpasswd
%{_sbindir}/syslogtocern
%{_sbindir}/thttpd
%attr(2775, thttpd, www) %{webroot}
%{_mandir}/man*/*

%changelog
* Fri May  4 2001 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file cleanup for Red Hat 7.
- New, clean initscript.
- Built the latest 2.21b version since 2.20b won't compile even with kgcc.
- Custom config file based on the contrib/redhat one.

* Wed Sep 13 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.20

* Mon Sep 11 2000 Bennett Todd <bet@rahul.net>
  - added thttpd.conf, took config info out of init script
  - switched to logging in /var/log, used pidfile

* Thu Jun 15 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.19

* Thu May 18 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.18

* Fri Mar 17 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.17

* Mon Feb 28 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.16

* Thu Feb 03 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.15

* Thu Jan 21 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.14

* Thu Jan  6 2000 Jef Poskanzer <jef@acme.com>
  - Updated to 2.13

* Mon Jan  3 2000 Bennett Todd <bet@rahul.net>
  - updated to 2.12, tweaked to move thttpd.init into tarball

* Mon Dec 13 1999 Bennett Todd <bet@mordor.net>
  - Updated to 2.09

* Fri Dec 10 1999 Bennett Todd <bet@mordor.net>
  - Updated to 2.08

* Wed Nov 24 1999 Bennett Todd <bet@mordor.net>
  - updated to 2.06, parameterized Version string in source url
  - changed to use "make install", simplified %files list

* Wed Nov 10 1999 Bennett Todd <bet@mordor.net>
  - Version 2.05, reset release to 1
  - dropped bugfix patch since Jef included that
  - streamlined install

* Sun Jul 25 1999 Bennett Todd <bet@mordor.net>
  - Release 4, added mime type swf

* Mon May  3 1999 Bennett Todd <bet@mordor.net>
  - Release 2, added patch to set cgi-timelimit up to 10 minutes
    fm default 30 seconds

* Wed Feb 10 1999 Bennett Todd <bet@mordor.net>
  - based on 2.00-2, bumped to 2.04, reset release back to 1
  - fixed a couple of broken entries in %install to reference %{buildroot}
  - simplified %files to populate /usr/doc/... with just [A-Z]* (TODO had gone
    away, this simplification makes it liklier to be trivially portable to
    future releases).
  - added %doc tags for the man pages

